
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was Config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

# provide meta-data
set(passwordfile_varname "PASSWORD_FILE")
set(passwordfile_static_varname "PASSWORD_FILE")
set(PASSWORD_FILE_DISPLAY_NAME "Passwordfile library")
set(PASSWORD_FILE_AUTHOR "Martchus")
set(PASSWORD_FILE_VERSION "4.0.1")
set(PASSWORD_FILE_VERSION_MAJOR "4")
set(PASSWORD_FILE_VERSION_MINOR "0")
set(PASSWORD_FILE_VERSION_PATCH "1")
set(PASSWORD_FILE_GIT_REV_COUNT "")
set(PASSWORD_FILE_GIT_LAST_COMMIT_ID "")
set(PASSWORD_FILE_URL "https://github.com/Martchus/passwordfile")
set(PASSWORD_FILE_DESCRIPTION "C++ library to read/write passwords from/to encrypted files")
set(PASSWORD_FILE_LICENSE "GPL-2")

# define general config
set(PASSWORD_FILE_IS_HEADER_ONLY NO)
set(PASSWORD_FILE_HAS_SHARED_LIB ON)
set(PASSWORD_FILE_HAS_STATIC_LIB ON)
set(PASSWORD_FILE_INCLUDE_DIRS "${PACKAGE_PREFIX_DIR}/include")
set(PASSWORD_FILE_BIN_DIR "${PACKAGE_PREFIX_DIR}/bin")
set(PASSWORD_FILE_LIB_DIR "${PACKAGE_PREFIX_DIR}/lib")
set(PASSWORD_FILE_MODULE_DIRS "${PACKAGE_PREFIX_DIR}/share/passwordfile/cmake/modules")
set(PASSWORD_FILE_CONFIG_DIRS "${PACKAGE_PREFIX_DIR}/share/passwordfile/cmake")
set(PASSWORD_FILE_PRIVATE_QT_MODULES "")
set(PASSWORD_FILE_PRIVATE_KF_MODULES "")
set(PASSWORD_FILE_PUBLIC_QT_MODULES "")
set(PASSWORD_FILE_PUBLIC_KF_MODULES "")
set(PASSWORD_FILE_HAS_QT_TRANSLATION_FILES )
set(PASSWORD_FILE_QT_RESOURCES )

# include files for shared/static specific configuration
set(PASSWORD_FILE_HAS_SHARED_LIB NO)
set(PASSWORD_FILE_HAS_STATIC_LIB NO)
file(GLOB PASSWORD_FILE_SPECIFIC_CONFIG_FILES
    LIST_DIRECTORIES OFF
    "${CMAKE_CURRENT_LIST_DIR}/passwordfile?*Config.cmake"
)
foreach(SPECIFIC_CONFIG_FILE IN LISTS PASSWORD_FILE_SPECIFIC_CONFIG_FILES)
    include("${SPECIFIC_CONFIG_FILE}")
endforeach()
unset(SPECIFIC_CONFIG_FILE)

# set default target: prefer shared lib over static lib
if(PASSWORD_FILE_HAS_SHARED_LIB)
    set(PASSWORD_FILE_LIB "passwordfile")
else()
    set(PASSWORD_FILE_LIB "passwordfile_static")
endif()

# define macro to ease use of library in projects following conventions of c++utilities' build script
macro(use_PASSWORD_FILE)
    # make CMake modules of the project available
    list(APPEND CMAKE_MODULE_PATH ${PASSWORD_FILE_MODULE_DIRS})
    # link against library (also "link" against header-only libs to get compile defs and interface link libs)
    link_directories(${PASSWORD_FILE_LIB_DIR})
    include(3rdParty)
    if(NOT ARGV0)
        set(PASSWORD_FILE_LINKAGE AUTO_LINKAGE)
    else()
        set(PASSWORD_FILE_LINKAGE "${ARG0}")
    endif()
    link_against_library(PASSWORD_FILE "${PASSWORD_FILE_LINKAGE}" REQUIRED)
    # add required Qt and KF modules
    list(APPEND IMPORTED_QT_MODULES
        ${PASSWORD_FILE_PUBLIC_QT_MODULES}
        ${PASSWORD_FILE_PRIVATE_QT_MODULES}
    )
    list(APPEND IMPORTED_KF_MODULES
        ${PASSWORD_FILE_PUBLIC_KF_MODULES}
        ${PASSWORD_FILE_PRIVATE_KF_MODULES}
    )
    # add required translations to APP_SPECIFIC_QT_TRANSLATION_FILES_ARRAY
    if(PASSWORD_FILE_HAS_QT_TRANSLATION_FILES)
        list(APPEND APP_SPECIFIC_QT_TRANSLATION_FILES passwordfile)
    endif()
endmacro()
